use std::{net::IpAddr, path::PathBuf, rc::Rc, sync::Mutex};

use openlipc_dyn::Lipc;

use crate::api;

pub struct State {
    pub api: api::Api,
    pub app_config: AppConfig,
    pub config: Rc<Mutex<kdash_protocol::Config>>,
    pub lipc: Rc<Mutex<Lipc>>,
}

pub struct AppConfig {
    pub net: String,
    pub router_ip: IpAddr,
    pub assets_path: PathBuf,
}

impl AppConfig {
    pub fn asset(&self, path: &str) -> PathBuf {
        self.assets_path.join(path)
    }
}
