use anyhow::Result;
use std::{fs, io::Write};

use crate::parse;

const RTC: &str = "/sys/devices/platform/mxc_rtc.0/wakeup_enable";
const POWER_STATE: &str = "/sys/power/state";

pub fn sleep(secs: u64) -> Result<()> {
    let content_str = fs::read_to_string(RTC)?;
    let content: u64 = parse::parse_number_from_start_unsigned(&content_str)?;

    if content == 0 {
        let mut rtc_file = fs::OpenOptions::new().write(true).open(RTC)?;
        rtc_file.write_all(secs.to_string().as_bytes())?;
    }

    let mut power_state_file = fs::OpenOptions::new().write(true).open(POWER_STATE)?;
    power_state_file.write_all(b"mem")?;

    Ok(())
}
